[CodeForces - 510D] Fox And Jumping(dp,stlmap,수론적 성질)
3928 단어 동적 계획 (dp)Codeforce~
Fox Ciel is playing a game. In this game there is an infinite long tape with cells indexed by integers (positive, negative and zero). At the beginning she is standing at the cell 0.
There are also n cards, each card has 2 attributes: length li and cost ci. If she pays ci dollars then she can apply i-th card. After applying i-th card she becomes able to make jumps of length li, i. e. from cell x to cell (x - li) or cell (x + li).
She wants to be able to jump to any cell on the tape (possibly, visiting some intermediate cells). For achieving this goal, she wants to buy some cards, paying as little money as possible.
If this is possible, calculate the minimal cost.
Input
The first line contains an integer n (1 ≤ n ≤ 300), number of cards.
The second line contains n numbers li (1 ≤ li ≤ 109), the jump lengths of cards.
The third line contains n numbers ci (1 ≤ ci ≤ 105), the costs of cards.
Output
If it is impossible to buy some cards and become able to jump to any cell, output -1. Otherwise output the minimal cost of buying such set of cards.
Examples
Input
3
100 99 9900
1 1 1
Output
2
Input
5
10 20 30 40 50
1 1 1 1 1
Output
-1
Input
7
15015 10010 6006 4290 2730 2310 1
1 1 1 1 1 1 10
Output
6
Input
8
4264 4921 6321 6984 2316 8432 6120 1026
4264 4921 6321 6984 2316 8432 6120 1026
Output
7237
Note
In first sample test, buying one card is not enough: for example, if you buy a card with length 100, you can't jump to any cell whose index is not a multiple of 100. The best way is to buy first and second card, that will make you be able to jump to any cell.
In the second sample test, even if you buy all cards, you can't jump to any cell whose index is not a multiple of 10, so you should output -1.
제목 대의:
n장의 카드를 주고 한 장에 두 개의 권치 l[i]와 c[i]가 있다.무한 길이의 종이 테이프에서 당신은 c[i]의 돈을 써서 카드 i를 구매할 수 있습니다. 이로부터 왼쪽이나 오른쪽으로 l[i] 단위를 뛸 수 있습니다.다른 카드를 구매하면 점프 단위를 더 얻을 수 있습니다.먼저 최소한 얼마의 돈을 써야만 종이 테이프의 임의의 위치로 뛰어오를 수 있는지를 요구한다.만약 안 된다면, 출력 -1.
문제 해결 보고서:
우선 모든 위치로 뛸 수 있는 만큼 충분한 조건은 1로 뛸 수 있다는 것을 알아야 한다.다시 말하면 임무를 완수하려면 반드시 1로 뛰고 1로 뛰면 모든 위치로 뛸 수 있기 때문에 문제는 k장의 카드를 골라 그들의 GCD를 1로 모으는 것으로 바뀌었다.
그리고 우리는 맵으로 스크롤 그룹 dp를 진행한다. 또 하나의 문제는 매번 비교할 때마다 모든 것을 비교하지 않고 비교한 두 개의 수의 gcd만 사용하면 된다는 것이다. 왜냐하면 gcd가 나올 수만 있다면 다른 것은 모두 나올 수 있기 때문이다.(전에 cf에서 등급차 수열을 모은 것도 이 사상을 운용했다)
시간 복잡도 문제에 대해서는 1e9 범위 내의 모든 숫자가 가지고 있는 질인자 개수 <=9을 증명할 수 있다.그래서 시간의 복잡도에서 과거를 말하는 거야.
AC 코드:
#include
#include
#include
#include
#include
이 내용에 흥미가 있습니까?
현재 기사가 여러분의 문제를 해결하지 못하는 경우 AI 엔진은 머신러닝 분석(스마트 모델이 방금 만들어져 부정확한 경우가 있을 수 있음)을 통해 가장 유사한 기사를 추천합니다:
동적 기획 문제 풀이의 일반적인 사고방식동규로 돌아가는 일반적인 전환 방법 귀속 함수에는 n개의 매개 변수가 있는데 하나의 n차원의 수조를 정의한다. 수조의 다음 표는 귀속 함수 매개 변수의 수치 범위이고 수조 원소의 값은 귀속 함수의 귀환 값이다. 이렇...
텍스트를 자유롭게 공유하거나 복사할 수 있습니다.하지만 이 문서의 URL은 참조 URL로 남겨 두십시오.
CC BY-SA 2.5, CC BY-SA 3.0 및 CC BY-SA 4.0에 따라 라이센스가 부여됩니다.